# OgreGpuProgram.h File Reference

`#include "OgrePrerequisites.h"`
`#include "OgreResource.h"`
`#include "OgreSharedPtr.h"`
`#include "OgreIteratorWrappers.h"`
`#include "OgreSerializer.h"`
`#include "OgreRenderOperation.h"`

Go to the source code of this file.

## Namespaces

namespace | Ogre

## Typedefs

typedef std::map< String, GpuConstantDefinition > | GpuConstantDefinitionMap
typedef ConstMapIterator< GpuConstantDefinitionMap > | GpuConstantDefinitionIterator
typedef std::map< size_t, GpuLogicalIndexUse > | GpuLogicalIndexUseMap
typedef SharedPtr< GpuProgramParameters > | GpuProgramParametersSharedPtr
| Shared pointer used to hold references to GpuProgramParameters instances.

## Enumerations

enum | GpuProgramType { GPT_VERTEX_PROGRAM, GPT_FRAGMENT_PROGRAM, GPT_GEOMETRY_PROGRAM }
| Enumerates the types of programs which can run on the GPU. More...

enum

GpuConstantType {
GCT_FLOAT1 = 1, GCT_FLOAT2 = 2, GCT_FLOAT3 = 3, GCT_FLOAT4 = 4,
GCT_SAMPLER1D = 5, GCT_SAMPLER2D = 6, GCT_SAMPLER3D = 7, GCT_SAMPLERCUBE = 8,
GCT_SAMPLER1DSHADOW = 9, GCT_SAMPLER2DSHADOW = 10, GCT_MATRIX_2X2 = 11, GCT_MATRIX_2X3 = 12,
GCT_MATRIX_2X4 = 13, GCT_MATRIX_3X2 = 14, GCT_MATRIX_3X3 = 15, GCT_MATRIX_3X4 = 16,
GCT_MATRIX_4X2 = 17, GCT_MATRIX_4X3 = 18, GCT_MATRIX_4X4 = 19, GCT_INT1 = 20,
GCT_INT2 = 21, GCT_INT3 = 22, GCT_INT4 = 23, GCT_UNKNOWN = 99
}

| Enumeration of the types of constant we may encounter in programs. More...

## Typedef Documentation

typedef ConstMapIterator<GpuConstantDefinitionMap> Ogre::GpuConstantDefinitionIterator

| Definition at line 146 of file OgreGpuProgram.h.

typedef std::map<String, GpuConstantDefinition> Ogre::GpuConstantDefinitionMap

| Definition at line 145 of file OgreGpuProgram.h.

typedef std::map<size_t, GpuLogicalIndexUse> Ogre::GpuLogicalIndexUseMap

| Definition at line 226 of file OgreGpuProgram.h.

typedef SharedPtr<GpuProgramParameters> Ogre::GpuProgramParametersSharedPtr

| Shared pointer used to hold references to GpuProgramParameters instances. Definition at line 1393 of file OgreGpuProgram.h.

## Enumeration Type Documentation

enum Ogre::GpuConstantType

Enumeration of the types of constant we may encounter in programs.

Note:
  Low-level programs, by definition, will always use either float4 or int4 constant types since that is the fundamental underlying type in assembler.

Enumeration values:

  GCT_FLOAT1 |
  GCT_FLOAT2 |
  GCT_FLOAT3 |
  GCT_FLOAT4 |
  GCT_SAMPLER1D |
  GCT_SAMPLER2D |
  GCT_SAMPLER3D |
  GCT_SAMPLERCUBE |
  GCT_SAMPLER1DSHADOW |
  GCT_SAMPLER2DSHADOW |
  GCT_MATRIX_2X2 |
  GCT_MATRIX_2X3 |
  GCT_MATRIX_2X4 |
  GCT_MATRIX_3X2 |
  GCT_MATRIX_3X3 |
  GCT_MATRIX_3X4 |
  GCT_MATRIX_4X2 |
  GCT_MATRIX_4X3 |
  GCT_MATRIX_4X4 |
  GCT_INT1 |
  GCT_INT2 |
  GCT_INT3 |
  GCT_INT4 |
  GCT_UNKNOWN |

Definition at line 55 of file OgreGpuProgram.h.

enum Ogre::GpuProgramType

Enumerates the types of programs which can run on the GPU.

Enumeration values:

  GPT_VERTEX_PROGRAM |
  GPT_FRAGMENT_PROGRAM |
  GPT_GEOMETRY_PROGRAM |

Definition at line 43 of file OgreGpuProgram.h.

Copyright © 2008 Torus Knot Software Ltd
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Sat Apr 11 13:46:44 2009